package com.ruoyi.web.controller.study;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.enums.FileType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.utils.uuid.IdUtils;
import com.ruoyi.invest.domain.TStudyInformation;
import com.ruoyi.invest.service.ITStudyInformationService;
import com.ruoyi.system.service.ISysDictDataService;
import com.ruoyi.tool.service.ITUnifyFileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 财务报表Controller
 * 
 * @author ruoyi
 * @date 2024-02-26
 */
@Api(tags = "研究资料管理-财务报表")
@RestController
@RequestMapping("/study/financialStatements")
public class FinancialStatementsController extends BaseController
{
    @Autowired
    private ITStudyInformationService tStudyInformationService;

    @Autowired
    private ITUnifyFileService tUnifyFileService;

    @Autowired
    private ISysDictDataService dictDataService;

    /**
     * 查询财务报表列表
     */
    @ApiOperation("查询财务报表列表")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:list')")
    @GetMapping("/list")
    public TableDataInfo list(TStudyInformation tStudyInformation)
    {
        startPage();
        tStudyInformation.setCreateBy(getNickName());//默认登陆人权限
        tStudyInformation.setContractType("g");
        List<TStudyInformation> list = tStudyInformationService.selectTStudyInformationList(tStudyInformation);
        return getDataTable(list);
    }

    /**
     * 导出财务报表列表
     */
    @ApiOperation("导出财务报表列表")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:export')")
    @Log(title = "财务报表", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, TStudyInformation tStudyInformation)
    {
        tStudyInformation.setCreateBy(getNickName());//默认登陆人权限
        tStudyInformation.setContractType("g");
        List<TStudyInformation> list = tStudyInformationService.selectTStudyInformationList(tStudyInformation)
                .stream().map(n -> {
                    n.setContractType(dictDataService.selectDictLabel("file_type",n.getContractType()));
                    return n;
                })
                .collect(Collectors.toList());
        ExcelUtil<TStudyInformation> util = new ExcelUtil<TStudyInformation>(TStudyInformation.class);
        util.exportExcel(response, list, "财务报表数据");
    }

    /**
     * 获取财务报表详细信息
     */
    @ApiOperation("获取财务报表详细信息")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id)
    {
        return success(tStudyInformationService.selectTStudyInformationById(id));
    }

    /**
     * 新增财务报表
     */
    @ApiOperation("新增财务报表")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:add')")
    @Log(title = "财务报表", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TStudyInformation tStudyInformation)
    {
        tStudyInformation.setId(IdUtils.fastSimpleUUID());
        tStudyInformation.setCreateBy(getNickName());
        // todo 保存附件信息
        tUnifyFileService.insertTUnifyFileList(tStudyInformation.getListFile(),
                null,
                tStudyInformation.getId(),
                String.valueOf(FileType.GEN.ordinal()),
                getNickName());

        return toAjax(tStudyInformationService.insertTStudyInformation(tStudyInformation));
    }

    /**
     * 修改财务报表
     */
    @ApiOperation("修改财务报表")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:edit')")
    @Log(title = "财务报表", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TStudyInformation tStudyInformation)
    {
        // todo 保存附件信息
        tUnifyFileService.insertTUnifyFileList(tStudyInformation.getListFile(),
                null,
                tStudyInformation.getId(),
                String.valueOf(FileType.GEN.ordinal()),
                getNickName());
        
        return toAjax(tStudyInformationService.updateTStudyInformation(tStudyInformation));
    }

    /**
     * 删除财务报表
     */
    @ApiOperation("删除财务报表")
    @PreAuthorize("@ss.hasPermi('study:financialStatements:remove')")
    @Log(title = "财务报表", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable String[] ids)
    {
        return toAjax(tStudyInformationService.updateTStudyInformationByIds(ids));
    }
}
